%%the cell_data structure can be downloaded from the publication at https://www.embopress.org/doi/full/10.15252/msb.20178140
%%all the data is contained in what is named cell_data in the following scripts


%%Figure 6(b)i
%Simulated OCT4 expression including differentiating with a shifting carrying capacity

load cell_data %%data set 
load cckernel %%use cckernel from initial conditions script or other cell cycle kernel of your choice
load initialoctkernel %%use initialoct kernel from initial conditions script of kernel of your choice

pd2=makedist('Uniform',900,1200); %a distribution for the initial conditions of the differentiated cells
ccpd=cckernel;

Npp=14; %starting number of pluripotent cells
Ndiff=2; %starting numnber of differentiated cells
eventspp=700; %how many divisions events for pp cells
eventsdiff=500; %how many division events for diff cells
r=0.015; %regulation parameter r for pluripotent
rdiff=0.008; %regulation parameter r for differentiated
kpp=1500; %carrying capacity pp cells
kdiff=1100; %carrying capacity diff cells
sigmaadiff=25; %additive noise
sigmaapp=35; %additive noise
sigmampp=0.035; %multiplicative noise
sigmamdiff=0.03; %multiplicative noise
dt=1; %time step 
kchangetime=20; %first shift
kchangetimediff=43; %differentiated shift
H=0.38; %Hurst exponent

%set up pp cells
for i=1:Npp
cctime(i)=random(ccpd)*12; %cell initial cell cycle timeframes
cellstartingtime(i)= unifrnd(0,cctime(i));%choose a random time between 0 and the cell cycle time for the cell to begin at 
cctimeframes(i)=cctime(i)-cellstartingtime(i); %remainder of cell cycle
initialoct(i)=log(random(initialoctkernel)); %initial OCT4 
OCT4pp(1:floor(cctimeframes(i)),i)=loglogistic_bothnoise(initialoct(i), 1, floor(cctimeframes(i)), dt, kpp, r, sigmaapp, sigmampp,H); %%first cells OCT4 time series
celldivisiontimespp(i)=floor(cctimeframes(i)); %cell division time
if celldivisiontimespp(i)==0 %correct for if the division time is 0 and make it 1 
    celldivisiontimespp(i)=1;
end
end


%set up diff cells
for i=1:Ndiff
cctime(i)=random(ccpd)*12; %cell initial cell cycle timeframes
cellstartingtime(i)= unifrnd(0,cctime(i));%choose a random time between 0 and the cell cycle time for the cell to begin at 
cctimeframes(i)=cctime(i)-cellstartingtime(i); %remainder of cell cycle
initialoct(i)=log(random(pd2)); %initial OCT4 
OCT4diff(1:floor(cctimeframes(i)),i)=loglogistic_bothnoise(initialoct(i), 1, floor(cctimeframes(i)), dt, kdiff, r, sigmaadiff, sigmamdiff,H); %%first cells OCT4 values
celldivisiontimesdiff(i)=floor(cctimeframes(i)); %cell division time
if celldivisiontimesdiff(i)==0 %correct for if the division time is 0 and make it 1 
    celldivisiontimesdiff(i)=1;
end 
end


%%for ppcells
for j=1:eventspp %for each cell division (event)
dividingcellID=find(celldivisiontimespp==min(celldivisiontimespp)); %find which cell is next to divide 
if length(dividingcellID)>1 %if two cells want to divide at once pick one randomly
pos = randi(length(dividingcellID));
cellid=dividingcellID(pos);
else 
cellid=dividingcellID;
end
newcctime1=random(ccpd)*12;
newcctime2=random(ccpd)*12;
while newcctime1<100
    newcctime1=random(ccpd)*12;
end 
while newcctime2<100
    newcctime2=random(ccpd)*12;
end 

%if we're past 25 hours change carrying capacity
if celldivisiontimespp(cellid)>kchangetime*12
    kpp=1000;
end

motherfinaloct=OCT4pp(celldivisiontimespp(cellid),cellid); %note mother cell final OCT4
OCT4pp(celldivisiontimespp(cellid)+1:celldivisiontimespp(cellid)+floor(newcctime1),cellid)= loglogistic_bothnoise(motherfinaloct, 1, floor(newcctime1), dt, kpp, r, sigmaapp,sigmampp,H); %update current cell
OCT4pp(celldivisiontimespp(cellid)+1:celldivisiontimespp(cellid)+floor(newcctime2),Npp+1)=loglogistic_bothnoise(motherfinaloct, 1, floor(newcctime2), dt, kpp, r, sigmaapp,sigmampp,H); %new cell
celldivisiontimespp(Npp+1)=celldivisiontimespp(cellid)+floor(newcctime2); %new cell division time
celldivisiontimespp(cellid)= celldivisiontimespp(cellid)+floor(newcctime1); %update cell division time for the cell that's dividing
Npp=Npp+1; %number of cells counter

end

%%for diffcells
for j=1:eventsdiff %for each cell division (event)
dividingcellID=find(celldivisiontimesdiff==min(celldivisiontimesdiff)); %find which cell is next to divide 
if length(dividingcellID)>1 %if two cells want to divide at once pick one randomly
pos = randi(length(dividingcellID));
cellid=dividingcellID(pos);
else 
cellid=dividingcellID;
end
newcctime1=random(ccpd)*12;
newcctime2=random(ccpd)*12;
while newcctime1<100
    newcctime1=random(ccpd)*12;
end 
while newcctime2<100
    newcctime2=random(ccpd)*12;
end 

%if we're past 25 hours update carrying capacity and regulation parameter
if celldivisiontimesdiff(cellid)>kchangetimediff*12
    kdiff=300;
    r=rdiff;
end 

motherfinaloct=OCT4diff(celldivisiontimesdiff(cellid),cellid);
OCT4diff(celldivisiontimesdiff(cellid)+1:celldivisiontimesdiff(cellid)+floor(newcctime1),cellid)= loglogistic_bothnoise(motherfinaloct, 1, floor(newcctime1), dt, kdiff, r, sigmaadiff,sigmamdiff,H); %update current cell
OCT4diff(celldivisiontimesdiff(cellid)+1:celldivisiontimesdiff(cellid)+floor(newcctime2),Ndiff+1)=loglogistic_bothnoise(motherfinaloct, 1, floor(newcctime2), dt, kdiff, r, sigmaadiff,sigmamdiff,H); %new cell
celldivisiontimesdiff(Ndiff+1)=celldivisiontimesdiff(cellid)+floor(newcctime2); %new cell division time
celldivisiontimesdiff(cellid)= celldivisiontimesdiff(cellid)+floor(newcctime1); %update cell division time for the cell that's dividing
Ndiff=Ndiff+1;
end

%plot the OCT4 over time
timestepspp=[1:1:length(OCT4pp)];
timestepsdiff=[1:1:length(OCT4diff)];
Time=68;

figure
for i=1:Npp
    octvals=(OCT4pp(:,i));
    f=find((octvals>0) & (octvals<10));
    plot(timestepspp(f)/12,exp(octvals(f)),'Color',[0.3 0.3 0.8])
    lifetimes=length(f);
    hold on 
end
for i=1:Ndiff
    octvals=(OCT4diff(:,i));
    f=find((octvals>0) & (octvals<10));
    plot(timestepsdiff(f)/12,exp(octvals(f)),'Color',[0.1 0.8 0.2])
    lifetimes=length(f);
    hold on 
end
xlabel('Time (hours)')
ylabel('OCT4')
xlim([0 68])
ax = gca;
ax.YAxis.Exponent = 3;
ylim([0 3150])




%%Figure 6(b)ii
%mean OCT4 over time 
groups=[1:(68*12-1)/70:68*12];
groups=round(groups);

%for pluripotent cells
for i=1:length(groups)-1
    selectoct=OCT4pp(groups(i):groups(i+1),:);
    f=find((selectoct>0) & (selectoct<10));
    selectoct=selectoct(f);
    expvals=exp(selectoct(:));
    expvals=expvals(expvals~=inf);
    meanpp(i)=mean(expvals);
    stdpp(i)=std(expvals);  
    medoctpp(i)=median(expvals);
    uqoctpp(i)=quantile(expvals,0.75);
    lqoctpp(i)=quantile(expvals,0.25);
    sdoctpp(i)=std(expvals);
    pdf1=fitdist(expvals,'Kernel','Bandwidth',50);
    xvals=[min(expvals):1:max(expvals)];
    yvals=pdf(pdf1,xvals);
    modeoctpp(i)=xvals(find(yvals==max(yvals)));
    selectoct=[];
end
groupcenterspp=(groups+circshift(groups,-1))/2;
groupcenterspp(end)=[];

%for differentiated cells
for i=1:length(groups)-1
    selectoct=OCT4diff(groups(i):groups(i+1),:);
    f=find((selectoct>0) & (selectoct<10));
    selectoct=selectoct(f);
    expvals=exp(selectoct(:));
    expvals=expvals(expvals~=inf);
    meandiff(i)=mean(expvals);
    stddiff(i)=std(expvals);
    medoctdiff(i)=median(expvals);
    uqoctdiff(i)=quantile(expvals,0.75);
    lqoctdiff(i)=quantile(expvals,0.25);
    sdoctdiff(i)=std(expvals);
    pdf1=fitdist(expvals,'Kernel','Bandwidth',200);
    xvals=[min(expvals):1:max(expvals)];
    yvals=pdf(pdf1,xvals);
    modeoctdiff(i)=xvals(find(yvals==max(yvals)));
    selectoct=[];
end
groupcentersdiff=(groups+circshift(groups,-1))/2;
groupcentersdiff(end)=[];

%plot figure
figure
shadedErrorBar(groupcenterspp/12,meanpp,stdpp,'lineprops',{'s-','LineStyle','none','Color',[0.3 0.3 0.8],'MarkerSize',4,'MarkerEdgeColor',[0.3 0.3 0.8],'MarkerFaceColor',[0.3 0.3 0.8]})
hold on
shadedErrorBar(groupcentersdiff/12,meandiff, stddiff,'lineprops',{'d-','LineStyle','none','Color',[0.1 0.8 0.2],'MarkerSize',3,'MarkerEdgeColor',[0.1 0.8 0.2],'MarkerFaceColor',[1 1 1]})
xlabel('Time (hours)')
ylabel('Mean OCT4')
xlim([0 68])
ylim([0 2100])
box on
ax = gca;
ax.YAxis.Exponent = 3;
yticks([0 1000 2000])

