function [Xt] = loglogistic_bothnoise_allee(x0, t0, tf, dt, k, r, sigmaa,sigmam,H,a)
% x0 -- initial value of random variable
% t0 -- start time
% tf -- end time
% dt -- time increment
% f -- function associated with the deterministic part of the SDE
% g -- funciton associated with the stochastic part of the SDE
t=t0:dt:tf; %sets time interval
n=max(size(t)); %determines number of iterations

Xt=zeros(n,1); %initializes vector and sets the initial condition
Xt(1)=x0;

f=@(x) r*(1-(exp(x)/k))*((exp(x)-a)/k); %sets up logistic sde
fbmnoise=ffgn(1,H,1,n,0); %generate the fractional brownian noise

for i=1:n-1
    Xt(i+1)=Xt(i)+f(Xt(i))*dt+sigmaa*fbmnoise(i)./exp(Xt(i))*dt+sigmam*fbmnoise(i)*dt;
end

end