function [s1] = loglogisticfbm(r, k, sigma, x0, t0, tf, dt,H)

% r growth rate
% k carrying capacity
% dt time increment 
% x0 %initial population size
% t0 %starting time
% tf %final time
% sigma is the drift

f=@(x) r*(1-(exp(x)/k)); %sets up logistic sde
g=@(x) sigma;
s1=eulersdefbm(x0,t0,tf,dt,f,g,H); %Runs approximation using euler-maruyama

end 